/**
Problema: Securitate
Rezolvare: Răzvan Ardelean
*/

#include <iostream>
#include <cstdio>
#include <cstring>
#define NAlfabet ('Z'-'A' +1)

using namespace std;

bool e_litera_mica(char c)
{
    if('a' <= c && c <= 'z')
        return true;
    return false;
}
bool e_litera_mare(char c)
{
    if('A' <= c && c <= 'Z')
        return true;
    return false;
}

int get_nr_ordine(char c)
{
    if(e_litera_mica(c))
        return c-'a';
    if(e_litera_mare(c))
        return c-'A';
    return 0;
}

void set_nr_ordine(char &c, int nr)
{
    if(e_litera_mica(c))
        c = 'a' + nr;
    else
        c = 'A' + nr;
}

void cript_cuvant(char *cuv, char *key)
{
    for(int i = 0; i < strlen(cuv); i++)
    {
        int nr = (get_nr_ordine(cuv[i])+get_nr_ordine(key[i%strlen(key)])+1 + NAlfabet)%NAlfabet;
        set_nr_ordine(cuv[i], nr);
    }
}

char text[10015];
char MasterKey[10015];
char *cuvinte[10015];
int n;

void cript_text()
{
    n = 0;
    char *last, *crt;
    last = strtok(text, " ");
    cuvinte[n++] = last;
    while(crt = strtok(NULL, " "))
    {
        MasterKey[n] = 'a'+(crt-last-strlen(last)-1)%NAlfabet;
        char key[30];
        key[0] = MasterKey[n];
        strcpy(key+1, crt);
        cript_cuvant(last, key);
        last = crt;
        cuvinte[n++] = last;
    }
    MasterKey[n] = NULL;
}

void afisare()
{
    for(int i = n-1; i >= 0; i--)
        printf("%s ", cuvinte[i]);
}

void rezolvare(int t)
{
    gets(text);
    cript_text();
    if(t == 1)
    {
        printf("%s\n", MasterKey+1);
        return;
    }
    else if(t == 2)
        afisare();
}

int main()
{
    freopen("securitate.in", "r", stdin);
    freopen("securitate.out", "w", stdout);
    int t;
    scanf("%d\n", &t);
    rezolvare(t);
    return 0;
}
