/**
Solutie O(2^N * N^2) Inelus Gabriel-Robert
*/
#include <bits/stdc++.h>

#define Nmax 200005
using namespace std;

vector<int> G[Nmax];
queue<int> Q;
bitset<Nmax> used;
int color[Nmax],N,M;
bool bad = false;

void Read_Input(void){
    scanf("%d%d",&N,&M);
    int a,b;
    for(int i = 1; i <= M; ++i){
        scanf("%d%d",&a,&b);
        G[a].push_back(b);
        G[b].push_back(a);
    }
}


void Print(){
    for(int i = 1; i <= N; ++i)
        if(color[i] == color[1])
            printf("%d ",i);
    printf("\n");
    for(int i = 1; i <= N; ++i)
        if(color[i] != color[1])
            printf("%d ",i);
    printf("\n");
}

bool BFS(int k)
{
    used = 0;
    Q.push(k);
    used[k] = 1;
    while(!Q.empty())
    {
        k = Q.front(); Q.pop();
        for(auto it : G[k])
            if(!used[it])
            {
                if(color[it] == 3 - color[k])
                {
                    Q.push(it);
                    used[it] = 1;
                }
                else{
                    while(!Q.empty()) Q.pop();
                    return true;
                }
            }
            else if(color[it] != 3 - color[k]){
                while(!Q.empty()) Q.pop();
                return true;
            }
    }
    for(int i = 1; i <= N; ++i)
        if(!used[i])
            return true;
    return false;
}

void Bipartite(){
    bad = true;
    for(int MASK = 0; MASK < (1<<N); ++ MASK){
        for(int j = 0; j < N; ++j)
            if(MASK & (1<<j) )
                color[j + 1] = 1;
            else
                color[j + 1] = 2;
        bad = BFS(1);
        if(bad == false){
            Print();
            return;
        }
    }
    if(bad == true)
        printf("-1\n");
}

int main(){
    freopen("hogwarts.in","r",stdin);
    freopen("hogwarts.out","w",stdout);
    Read_Input();
    if(N > 20)
        printf("-1\n");
    else
        Bipartite();
    return 0;
}
