/**
Solutie O(KlogK) sau O(N^2) in functie de cazul favorabil Gabriel-Robert Inelus
*/

#include <bits/stdc++.h>
#define Kmax 200005
#define Nmax 2005
#define cntmax 2000005

using namespace std;
long long N,K;

map<long long,int> activ,inode;
queue<long long> Q;
queue<pair<int,int> > Q2;
bitset<Kmax> used;

long long node[Kmax];
long long edge[Kmax][4];
int ncc,Size[cntmax];
int cnt[cntmax];
int DP[Nmax][Nmax],usd[Nmax][Nmax];

const int dx[4] ={0,0,1,-1},
          dy[4] ={1,-1,0,0};

#define DIM 66613
char Buffer[DIM];
int pz = DIM - 1;

long long code(pair<long long,long long> p) {
    return (p.first - 1) * 1LL*N + p.second;
}

pair<long long,long long> decode(long long val){
    long long x,y;
    x = (val - 1) / N + 1;
    y = (val - 1) % N + 1;
    return {x,y};
}

long long North(long long val){
    val -= N;
    if(val < 1) return -1;
    return val;
}

long long South(long long val){
    val += N;
    if(val > N * N) return -1;
    return val;
}

long long East(long long val){
    auto p = decode(val);
    ++p.second;
    if(p.second > N) return -1;
    return code(p);
}

long long West(long long val){
    auto p = decode(val);
    --p.second;
    if(p.second < 1) return -1;
    return code(p);
}

void BFS(long long k){
    long long ik = inode[k],v,iv;
    used[ik] = 1;
    Q.push(ik);
    while(!Q.empty()){
        k = Q.front(); Q.pop();
        for(int j = 0; j <= 3; ++j){
            v = edge[k][j];
            iv = inode[v];
            if(v == -1 || v == 0 || used[iv] == 1 || activ[v] != 1)
                continue;
            ++Size[ncc];
            used[iv] = 1;
            Q.push(iv);
        }
    }
}

int BFS_lowN(int i,int j){
    Q2.push({i,j});
    usd[i][j] = 1;
    int cnt = 1;
    while(!Q2.empty()){
        auto k = Q2.front();
        i = k.first; j = k.second;
        Q2.pop();
        if(DP[i][j] == 0)
            continue;
        for(int k = 0; k <= 3; ++k)
            if(!usd[i+dx[k]][j+dy[k]] && DP[i+dx[k]][j+dy[k]] == 1){
                ++cnt;
                usd[i+dx[k]][j+dy[k]] = 1;
                Q2.push({i+dx[k],j+dy[k]});
            }
    }
    return cnt;
}

void Read_Input()
{
    scanf("%lld%lld",&N,&K);
    long long a,b;
    for(int i = 1; i <= K; ++i){
        scanf("%lld%lld",&a,&b);
        if(N > 2000){
            node[i] = code({a,b});
            inode[node[i]] = i;
            edge[i][0] = North(node[i]);
            edge[i][1] = South(node[i]);
            edge[i][2] = East(node[i]);
            edge[i][3] = West(node[i]);
            activ[node[i]] = 1;
            continue;
        }
        DP[a][b] = 1;
    }
}

void Solve_lowN(){
    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
            if(!usd[i][j] && DP[i][j] == 1){
                ++ncc;
                Size[ncc] = BFS_lowN(i,j);
            }
}

void Find_Solutions(){
    for(int i = 1; i <= K; ++i)
        if(used[i] == 0 ){
            Size[++ncc] = 1;
            BFS(node[i]);
        }
}

void Print_Solutions(){
    printf("%d\n",ncc);
    for(int i = 1; i <= ncc; ++i)
        cnt[Size[i]]++;
    for(int i = 1; i <= K; ++i)
        if(cnt[i])
            printf("%d %d\n",i,cnt[i]);
}

int main()
{
    freopen("mozaic.in","r",stdin);
    freopen("mozaic.out","w",stdout);

    Read_Input();
    if(N > 2000)
        Find_Solutions();
    else
        Solve_lowN();
    Print_Solutions();
    return 0;
}
