/**
Solutie O(KlogK) sau O(N^2) comvenabil Gabriel-Robert Inelus
*/

#include <bits/stdc++.h>
#define Kmax 200005
#define Nmax 2005
#define cntmax 2000005

using namespace std;
long long N,K;

map< pair<int ,int>, int> activ,inode;
queue<int> Q;
queue<pair<int,int> > Q2;
bitset<Kmax> used;
pair<int, int> node[cntmax];
int ncc,Size[cntmax];
int cnt[cntmax];
int DP[Nmax][Nmax],
   usd[Nmax][Nmax];

const int dx[4]={0,0,1,-1},
          dy[4]={1,-1,0,0};

void Read_Input()
{
    scanf("%lld%lld",&N,&K);
    long long a,b;
    for(int i = 1; i <= K; ++i)
    {
        scanf("%d%d",&node[i].first,&node[i].second);
        if(N > 2000)
        {
            activ[node[i]] = 1;
            inode[node[i]] = i;
            continue;
        }
        DP[node[i].first][node[i].second] = 1;
    }
}

bool out_bound(pair<int, int> p)
{
    if(p.first < 1 || p.first > N || p.second < 1 || p.second > N)
        return true;
    return false;
}

int BFS_lowN(int i,int j){
    Q2.push({i,j});
    usd[i][j] = 1;
    int cnt = 1;
    while(!Q2.empty()){
        auto k = Q2.front();
        i = k.first; j = k.second;
        Q2.pop();
        if(DP[i][j] == 0)
            continue;
        for(int k = 0; k <= 3; ++k)
            if(!usd[i+dx[k]][j+dy[k]] && DP[i+dx[k]][j+dy[k]] == 1){
                ++cnt;
                usd[i+dx[k]][j+dy[k]] = 1;
                Q2.push({i+dx[k],j+dy[k]});
            }
    }
    return cnt;
}

void BFS(pair<int, int> p)
{
    int k = inode[p],iv;
    pair<int, int> v;
    used[k] = 1;
    Q.push(k);
    while(!Q.empty()){
        k = Q.front(); Q.pop();
        p = node[k];
        for(int j = 0; j <= 3; ++j){
            v.first = p.first + dx[j];
            v.second = p.second + dy[j];
            iv = inode[v];

            if(out_bound(v)|| used[iv] == 1 || activ[v] != 1)
                continue;

            ++Size[ncc];
            used[iv] = 1;
            Q.push(iv);
        }
    }
}

void Find_Solutions()
{
    for(int i = 1; i <= K; ++i)
        if(used[i] == 0 ){
            Size[++ncc] = 1;
            BFS(node[i]);
        }
}

void Solve_lowN(){
    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
            if(!usd[i][j] && DP[i][j] == 1){
                ++ncc;
                Size[ncc] = BFS_lowN(i,j);
            }
}

void Print_Solutions(){
    printf("%d\n",ncc);
    for(int i = 1; i <= ncc; ++i)
        cnt[Size[i]]++;
    for(int i = 1; i <= K; ++i)
        if(cnt[i])
            printf("%d %d\n",i,cnt[i]);
}

int main()
{
    freopen("mozaic.in","r",stdin);
    freopen("mozaic.out","w",stdout);

    Read_Input();
    if(N > 2000)
        Find_Solutions();
    else
        Solve_lowN();
    Print_Solutions();

    return 0;
}
